import 'dart:developer';

import 'package:feelverapp/model/Login/login_model.dart';


import 'package:feelverapp/service/Loading.dart';

import 'package:feelverapp/service/api.dart';
import 'package:feelverapp/service/base_presenter.dart';
import 'package:feelverapp/ui/login/login.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:rflutter_alert/rflutter_alert.dart';



class LoginPresenter extends BasePresenter<LoginPage> {
  Api _api;

  final formKey = GlobalKey<FormState>();
  TextEditingController emailCtrl = TextEditingController();
  TextEditingController passCtrl = TextEditingController();





  LoginPresenter(State<LoginPage> state) : super(state);

  onSignIn() async {
    if (emailCtrl.text.isEmpty) {
      Alert(
        style: AlertStyle(
      animationType: AnimationType.fromTop,
      isCloseButton: false,
     
      ),
        context: state.context,
        title: "กรุณากรอกอีเมล์",
        content: Icon(Icons.warning,color: Colors.orange,size: 80,),
        buttons: [
          DialogButton(
            color:  Color.fromRGBO(106, 179, 170, 1),
            onPressed: () => Navigator.pop(state.context),
            child: Text(
              "ตกลง",
              style: TextStyle(color: Colors.white, fontSize: 20),
            ),
          )
        ]).show();
    }
     if (passCtrl.text.isEmpty) {
      Alert(
        style: AlertStyle(
      animationType: AnimationType.fromTop,
      isCloseButton: false,
     
      ),
        context: state.context,
        title: "กรุณากรอกรหัสผ่าน",
        content: Icon(Icons.warning,color: Colors.orange,size: 80,),
        buttons: [
          DialogButton(
            color:  Color.fromRGBO(106, 179, 170, 1),
            onPressed: () => Navigator.pop(state.context),
            child: Text(
              "ตกลง",
              style: TextStyle(color: Colors.white, fontSize: 20),
            ),
          )
        ]).show();
    }
  else letSignIn();
  }

  

  letSignIn() async {
 LoadingView(state.context).show();
    _api = Api<LoginModel>();

    var res = await _api.login({
      "access_type":"portal",
      "access_status":"customer",
      "email": emailCtrl.text,
      'password':passCtrl.text
    });
 LoadingView(state.context).hide();


    if (res.fail == null) {
      Alert(
        style: AlertStyle(
      animationType: AnimationType.fromTop,
      isCloseButton: false,
     
      ),
        context: state.context,
        title: "เข้าสู่ระบบสำเร็จ",
        content: Icon(Icons.check_circle,color: Color.fromRGBO(106, 179, 170, 1),size: 80,),
        buttons: [
          DialogButton(
            color:  Color.fromRGBO(106, 179, 170, 1),
            onPressed: () => Navigator.pop(state.context),
            child: Text(
              "ตกลง",
              style: TextStyle(color: Colors.white, fontSize: 20),
            ),
          )
        ]).show();
      LoginModel model = res.success;
     // print("Username ="+"${model.user}");
     
      print("Token ="+"${model.token}");
          } else {
   Alert(
        style: AlertStyle(
      animationType: AnimationType.fromTop,
      isCloseButton: false,
     
      ),
        context: state.context,
        title: "อีเมล์หรือรหัสผ่านผิด",
        content: Icon(Icons.warning,color: Colors.orange,size: 80,),
        buttons: [
          DialogButton(
            color:  Color.fromRGBO(106, 179, 170, 1),
            onPressed: () => Navigator.pop(state.context),
            child: Text(
              "ลองอีกครั้ง",
              style: TextStyle(color: Colors.white, fontSize: 20),
            ),
          )
        ]).show();
    }
  }


  // facebookLogin() async {
  //   try {
  //     await _facebookLogin.logIn(['email']).then((result) async {
  //       var fbData = await Api().getFacebookInfo(result.accessToken.token);
  //       print(fbData);

  //       await _letSocialSignIn(result.accessToken.userId, 'facebook')
  //           .then((value) {
  //         if (value) {
  //           Navigator.popUntil(state.context, (route) => route.isFirst);
  //           Navigator.pushReplacement(state.context, CupertinoPageRoute(builder: (_) => 
              
  //     NavigatorPage(),
  //           ));
  //         } else {
  //           Navigator.push(
  //               state.context,
  //               CupertinoPageRoute(
  //                   builder: (_) => SignUpEmail(
  //                         socialType: SocialType.facebook,
  //                         socialData: new RegisterSocialDataModel(
  //                           socialId: result.accessToken.userId,
  //                           token: result.accessToken.token,
  //                           email: fbData['email'],
  //                           firstName: fbData['first_name'],
  //                           lastName: fbData['last_name'],
  //                         ),
  //                       )));
  //         }
  //       });
  //     });
  //   } catch (e) {
  //     print(e);
  //   }
  // }

 
}
